@charset "UTF-8";

// Reset
@import "minireset.scss";
@import "normalize.scss";

// Fonts
$font-family-standard: 'Solway, -apple-system, BlinkMacSystemFont, "Segoe UI", Roboto, Ubuntu, "Helvetica Neue", Helvetica, sans-serif';
$font-family-mono: 'CourierPrime, Consolas, Monaco, "Andale Mono", "Ubuntu Mono", monospace';

// Dark theme
$theme-dark-bg-primary: #1f1d30;
$theme-dark-bg-secondary: #120f25;
$theme-dark-bg-shade-1: #4e2b75;
$theme-dark-bg-shade-2: #1b1125;
$theme-dark-bg-shade-3: #000;

$theme-dark-fg-primary: #ded9e0;
$theme-dark-fg-secondary: #a8a3b3;
$theme-dark-fg-shade-1: #8395fa;
$theme-dark-fg-shade-2: #a861c9;
$theme-dark-fg-shade-3: #000;

// Light theme
$theme-light-bg-primary: #e7ddff;
$theme-light-bg-secondary: #ddccf0;
$theme-light-bg-shade-1: #cbaee6;
$theme-light-bg-shade-2: #afa7b3;
$theme-light-bg-shade-3: #afa7b3;

$theme-light-fg-primary: #1d1729;
$theme-light-fg-secondary: #413b46;
$theme-light-fg-shade-1: #264dcc;
$theme-light-fg-shade-2: #b46ad1;
$theme-light-fg-shade-3: #222;

// Text sizes
$text-size-default: 16px;
$text-size-h1: 3rem;
$text-size-h2: 2rem; // rem
$text-size-h3: 1.7rem; // rem
$text-size-h4: 1.5rem; // rem
$text-size-h5: 1.3rem; // rem
$text-size-h6: 1rem; // rem
$text-size-smaller: 0.85rem;

// Responsive breakpoints
$content-width-max-lg: 60rem;
$content-width-max-md: 50rem;
$content-width-max-sm: 40rem;

// Useful variables
$text-size-hx-sm-factor: 0.85;
$transitions-duration: 0.2s;

// TODO
$content-margin: 1em;
$content-border-radius: 0.3rem;
$screen-margin: 1.5rem;
$element-max-height: 60vh;

:root {
    // Set theme colors as CSS variables do make theme responsive
    --color-bg-primary: #{$theme-light-bg-primary};
    --color-bg-secondary: #{$theme-light-bg-secondary};
    --color-bg-shade-1: #{$theme-light-bg-shade-1};
    --color-bg-shade-2: #{$theme-light-bg-shade-2};
    --color-bg-shade-3: #{$theme-light-bg-shade-3};
    
    --color-fg-primary: #{$theme-light-fg-primary};
    --color-fg-secondary: #{$theme-light-fg-secondary};
    --color-fg-shade-1: #{$theme-light-fg-shade-1};
    --color-fg-shade-2: #{$theme-light-fg-shade-2};
    --color-fg-shade-3: #{$theme-light-fg-shade-3};
    
    @media (prefers-color-scheme: dark) {
        --color-bg-primary: #{$theme-dark-bg-primary};
        --color-bg-secondary: #{$theme-dark-bg-secondary};
        --color-bg-shade-1: #{$theme-dark-bg-shade-1};
        --color-bg-shade-2: #{$theme-dark-bg-shade-2};
        --color-bg-shade-3: #{$theme-dark-bg-shade-3};
        
        --color-fg-primary: #{$theme-dark-fg-primary};
        --color-fg-secondary: #{$theme-dark-fg-secondary};
        --color-fg-shade-1: #{$theme-dark-fg-shade-1};
        --color-fg-shade-2: #{$theme-dark-fg-shade-2};
        --color-fg-shade-3: #{$theme-dark-fg-shade-3};
    }
    
    @keyframes blinking-smooth {
        0% {
            opacity: 0%;
        }
        35% {
            opacity: 0%;
        }
        50% {
            opacity: 100%;
        }
        85% {
            opacity: 100%;
        }
        100% {
            opacity: 0%;
        }
    }
    
    @media (prefers-reduced-motion: reduce) {
        @keyframes blinking-smooth {
            0% {
                opacity: 100%;
            }
        }
    }
    
    --transitions-duration: #{$transitions-duration};
    
    @media (prefers-reduced-motion: reduce) {
        // Not 0, because events are not fired otherwise
        --transitions-duration: 0.001s;
    }
}

// Defaults
html {
    font-family: #{$font-family-standard};
    font-size: $text-size-default;
}

body {
    // Body must fill entire page for flex to work
    display: flex;
    flex-direction: column;
    min-height: 100vh;
    
    background-color: var(--color-bg-primary);
    color: var(--color-fg-primary);
}

h1, h2, h3, h4, h5, h6 {
    font-weight: bold;
    margin: 1.3em 0 0.5em 0;
}

h1 {
    font-size: $text-size-h1;
    margin: 0.3em 0; // Override just for h1
    @media screen and (max-width: $content-width-max-sm) {
        font-size: max($text-size-h1 * $text-size-hx-sm-factor, 1rem);
    }
}

h2 {
    font-size: $text-size-h2;
    @media screen and (max-width: $content-width-max-sm) {
        font-size: max($text-size-h2 * $text-size-hx-sm-factor, 1rem);
    }
}

h3 {
    font-size: $text-size-h3;
    @media screen and (max-width: $content-width-max-sm) {
        font-size: max($text-size-h3 * $text-size-hx-sm-factor, 1rem);
    }
}

h4 {
    font-size: $text-size-h4;
    @media screen and (max-width: $content-width-max-sm) {
        font-size: max($text-size-h4 * $text-size-hx-sm-factor, 1rem);
    }
}

h5 {
    font-size: $text-size-h5;
    @media screen and (max-width: $content-width-max-sm) {
        font-size: max($text-size-h5 * $text-size-hx-sm-factor, 1rem);
    }
}

h6 {
    font-size: $text-size-h6;
    @media screen and (max-width: $content-width-max-sm) {
        font-size: max($text-size-h6 * $text-size-hx-sm-factor, 1rem);
    }
}

p {
    line-height: 1.4em;
    margin: $content-margin 0;
}

a {
    color: var(--color-fg-shade-1);
    text-decoration: none;
}

::-webkit-scrollbar {
    width: 0.5rem;
    height: 0.5rem;
    background: var(--color-bg-secondary);
}

::-webkit-scrollbar-thumb {
    background: var(--color-fg-secondary);
    
    &:hover {
        background: var(--color-fg-primary);
    }
}

::-webkit-scrollbar-corner {
    background: var(--color-bg-secondary);
}

// Additional resources
@import "fonts.scss";
@import "prism.scss";
@import "animate.scss";

// Top level elements
.site-main {
    display: flex;
    flex: 1 auto;
    justify-content: center;
    margin: $screen-margin;
    
    main {
        display: flex;
        flex: 1 auto;
        flex-direction: column;
        max-width: $content-width-max-lg;
    }
}

// Page components
@import "components/header";
@import "components/menu";
@import "components/footer";

@import "components/article";
@import "components/image";
@import "components/list";
@import "components/home";